diff --git a/src/main/java/net/minecraft/core/net/command/Commands.java b/src/main/java/net/minecraft/core/net/command/Commands.java
index 1d80ffa80..3a28ad487 100644
--- a/src/main/java/net/minecraft/core/net/command/Commands.java
+++ b/src/main/java/net/minecraft/core/net/command/Commands.java
@@ -2,6 +2,26 @@ package net.minecraft.core.net.command;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.net.command.commands.*;
+import net.minecraft.core.net.command.servercommands.BanCommand;
+import net.minecraft.core.net.command.servercommands.BanIpCommand;
+import net.minecraft.core.net.command.servercommands.ColorCommand;
+import net.minecraft.core.net.command.servercommands.DeopCommand;
+import net.minecraft.core.net.command.servercommands.DifficultyCommand;
+import net.minecraft.core.net.command.servercommands.EmotesCommand;
+import net.minecraft.core.net.command.servercommands.KickCommand;
+import net.minecraft.core.net.command.servercommands.ListCommand;
+import net.minecraft.core.net.command.servercommands.MeCommand;
+import net.minecraft.core.net.command.servercommands.NicknameCommand;
+import net.minecraft.core.net.command.servercommands.OpCommand;
+import net.minecraft.core.net.command.servercommands.PardonCommand;
+import net.minecraft.core.net.command.servercommands.PardonIpCommand;
+import net.minecraft.core.net.command.servercommands.SaveCommand;
+import net.minecraft.core.net.command.servercommands.SayCommand;
+import net.minecraft.core.net.command.servercommands.ScoreCommand;
+import net.minecraft.core.net.command.servercommands.ScoreboardCommand;
+import net.minecraft.core.net.command.servercommands.StopCommand;
+import net.minecraft.core.net.command.servercommands.WhitelistCommand;
+import net.minecraft.core.net.command.servercommands.WhoisCommand;
 import net.minecraft.server.MinecraftServer;
 
 import java.util.ArrayList;
@@ -41,7 +61,9 @@ public final class Commands {
 		if(commands.size() > 0) throw new RuntimeException();
 		
 		initCommands();
-		
+
+		commands.add(new BanCommand(server));
+		commands.add(new BanIpCommand(server));
 		commands.add(new StopCommand(server));
 		commands.add(new OpCommand(server));
 		commands.add(new DeopCommand(server));
@@ -53,7 +75,13 @@ public final class Commands {
 		commands.add(new ScoreCommand(server));
 		commands.add(new MeCommand(server));
 		commands.add(new EmotesCommand(server));
-		commands.add(new BiomeCommand());
+		commands.add(new WhitelistCommand(server));
+		commands.add(new SaveCommand(server));
+		commands.add(new PardonCommand(server));
+		commands.add(new PardonIpCommand(server));
+		commands.add(new KickCommand(server));
+		commands.add(new SayCommand(server));
+		commands.add(new ScoreboardCommand(server));
 	}
 	
 	public static void initClientCommands(Minecraft minecraft) {
diff --git a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
index 98695cb71..3c6d4e34e 100644
--- a/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ConsoleCommandSender.java
@@ -2,7 +2,7 @@ package net.minecraft.core.net.command;
 
 import org.apache.log4j.Logger;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.LogPrintStream;
 import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
@@ -23,7 +23,7 @@ public class ConsoleCommandSender implements CommandSender{
 	}
 
 	@Override
-	public EntityPlayer getPlayer() {
+	public Player getPlayer() {
 		return null;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/LocationTarget.java b/src/main/java/net/minecraft/core/net/command/LocationTarget.java
index ae8f090b4..67b3d1d7c 100644
--- a/src/main/java/net/minecraft/core/net/command/LocationTarget.java
+++ b/src/main/java/net/minecraft/core/net/command/LocationTarget.java
@@ -3,7 +3,7 @@ package net.minecraft.core.net.command;
 import static net.minecraft.core.util.helper.Utils.*;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -49,7 +49,7 @@ public class LocationTarget {
 	public int parse(String[] args, int offset) {
 		try {
 			if(!isNumber(args[offset])) {
-				EntityPlayer player = handler.getPlayer(args[offset]);
+				Player player = handler.getPlayer(args[offset]);
 				
 				if(player != null) {
 					setLocation(player);
@@ -137,29 +137,29 @@ public class LocationTarget {
 	public int getBlockX() {
 		checkPosition();
 		
-		return MathHelper.floor_double(x);
+		return MathHelper.floor(x);
 	}
 	
 	public int getBlockY() {
 		checkPosition();
 		
-		return MathHelper.floor_double(y);
+		return MathHelper.floor(y);
 	}
 	
 	public int getBlockZ() {
 		checkPosition();
 		
-		return MathHelper.floor_double(z);
+		return MathHelper.floor(z);
 	}
 	
 	public boolean isLocationEntity() {
-		return locationEntity != null && locationEntity instanceof EntityPlayer;
+		return locationEntity != null && locationEntity instanceof Player;
 	}
 	
 	public String getLocationEntityName() {
 		if(locationEntity == null) return null;
-		if(locationEntity instanceof EntityPlayer) {
-			EntityPlayer entityPlayer = (EntityPlayer) locationEntity;
+		if(locationEntity instanceof Player) {
+			Player entityPlayer = (Player) locationEntity;
 			return entityPlayer.username;
 		}
 		return null;
diff --git a/src/main/java/net/minecraft/core/net/command/PlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/PlayerCommandSender.java
index edccc167e..2a7877ab2 100644
--- a/src/main/java/net/minecraft/core/net/command/PlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/PlayerCommandSender.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.command;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 
 public abstract class PlayerCommandSender implements CommandSender{
 	
 	public PlayerCommandSender() {}
 
 	@Override
-	public abstract EntityPlayer getPlayer();
+	public abstract Player getPlayer();
 	
 }
diff --git a/src/main/java/net/minecraft/core/net/command/ServerCommand.java b/src/main/java/net/minecraft/core/net/command/ServerCommand.java
index 96a5e1d81..f9cc29a89 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerCommand.java
@@ -12,4 +12,11 @@ public abstract class ServerCommand extends Command{
 		this.server = server;
 	}
 
+	public void sendNoticeToOps(String name, String message)
+	{
+		String formattedMessage = name + TextFormatting.LIGHT_GRAY +  ": " + message;
+		server.playerList.sendChatMessageToAllOps(TextFormatting.LIGHT_GRAY + "(" + formattedMessage + ")");
+		MinecraftServer.logger.info(formattedMessage);
+	}
+
 }
diff --git a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
index 27a177b64..c9b8f8800 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerCommandHandler.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.net.command;
 
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.packet.ChatPacket;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.net.packet.Packet3Chat;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
@@ -21,7 +21,7 @@ public class ServerCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public @Nullable EntityPlayer getPlayer(String name) {
+	public @Nullable Player getPlayer(String name) {
 		return minecraftServer.playerList.getPlayerEntity(name);
 	}
 
@@ -31,8 +31,8 @@ public class ServerCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public void sendMessageToPlayer(EntityPlayer player, String messsage) {
-		minecraftServer.playerList.sendPacketToPlayer(player.username, new Packet3Chat(messsage, AES.keyChain.get(player.username)));
+	public void sendMessageToPlayer(Player player, String messsage) {
+		minecraftServer.playerList.sendPacketToPlayer(player.username, new ChatPacket(messsage, AES.keyChain.get(player.username)));
 	}
 
 	@Override
@@ -46,7 +46,7 @@ public class ServerCommandHandler implements CommandHandler{
 		
 		String message2 = "\2477" + sender.getName() + ": " + message;
 		
-		for(EntityPlayer p : minecraftServer.playerList.playerEntities) {
+		for(Player p : minecraftServer.playerList.playerEntities) {
 			if(minecraftServer.playerList.isOp(p.username)) {
 				if(sender.getPlayer() == null || sender.getPlayer() != p) {
 					sendMessageToPlayer(p, message2);
diff --git a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
index eea4757e6..88b6cbfb7 100644
--- a/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ServerPlayerCommandSender.java
@@ -1,18 +1,18 @@
 package net.minecraft.core.net.command;
 
+import net.minecraft.core.net.packet.ChatPacket;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet3Chat;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 public class ServerPlayerCommandSender extends PlayerCommandSender{
 
 	public final MinecraftServer server;
-	public final EntityPlayerMP player;
+	public final ServerPlayer player;
 	
-	public ServerPlayerCommandSender(MinecraftServer server, EntityPlayerMP player) {
+	public ServerPlayerCommandSender(MinecraftServer server, ServerPlayer player) {
 		this.player = player;
 		this.server = server;
 	}
@@ -24,15 +24,15 @@ public class ServerPlayerCommandSender extends PlayerCommandSender{
 
 	@Override
 	public void sendMessage(String string) {
-		player.playerNetServerHandler.sendPacket(new Packet3Chat(string, AES.keyChain.get(player.username)));
+		player.playerNetServerHandler.sendPacket(new ChatPacket(string, AES.keyChain.get(player.username)));
 	}
 
 	@Override
-	public EntityPlayer getPlayer() {
+	public Player getPlayer() {
 		return player;
 	}
 	
-	public EntityPlayerMP getPlayerMP() {
+	public ServerPlayer getPlayerMP() {
 		return player;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
index a1e68a7b3..389259946 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/BiomeCommand.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.command.commands;
 
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.*;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -17,7 +17,7 @@ extends Command {
     @Override
     public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
         if (args.length == 0 && sender instanceof PlayerCommandSender) {
-            EntityPlayer p = sender.getPlayer();
+            Player p = sender.getPlayer();
             World world = p.world;
             Biome biome = world.getBlockBiome((int) p.x, (int) p.y, (int) p.z);
             sender.sendMessage("Current biome: " + Registries.BIOMES.getKey(biome));
@@ -109,7 +109,7 @@ extends Command {
         }
     }
 
-    private int[] getBiomeCoords(Biome biome, EntityPlayer source) {
+    private int[] getBiomeCoords(Biome biome, Player source) {
         int[] xPattern = new int[] { 0, 1, 0, -1 };
         int[] zPattern = new int[] { 1, 0, -1, 0 };
         int runLength = 2;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java b/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
index 18d519976..af5c9e909 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/ClearCommand.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
@@ -17,7 +17,7 @@ public class ClearCommand extends Command{
 
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		EntityPlayer player = null;
+		Player player = null;
 		
 		if(args.length == 0) {
 			player = sender.getPlayer();
@@ -28,8 +28,8 @@ public class ClearCommand extends Command{
 		
 		if(player == null) throw new CommandError("Must be used by a player, or define a player name!");
 		
-		for(int i=0; i < player.inventory.getSizeInventory(); i++) {
-			player.inventory.setInventorySlotContents(i, null);
+		for(int i = 0; i < player.inventory.getContainerSize(); i++) {
+			player.inventory.setItem(i, null);
 		}
 		Arrays.fill(player.inventory.armorInventory, null);
 		
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GamemodeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GamemodeCommand.java
index 206711398..537f6b502 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GamemodeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GamemodeCommand.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.net.command.PlayerCommandSender;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -20,7 +21,7 @@ public class GamemodeCommand extends Command{
 		String gamemodeString = args[0];
 		
 		Gamemode gamemode;
-		EntityPlayer player;
+		Player player;
 		
 		try {
 			gamemode = Gamemode.gamemodesList[Integer.parseInt(gamemodeString)];
@@ -52,6 +53,9 @@ public class GamemodeCommand extends Command{
 
 	@Override
 	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+		if (sender instanceof PlayerCommandSender){
+			sender.sendMessage("/gamemode <gamemode>");
+		}
 		sender.sendMessage("/gamemode <gamemode> <player>");
 	}
 	
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
index 38cc02556..ebab270f7 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
@@ -4,7 +4,7 @@ import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.net.command.*;
-import net.minecraft.core.net.packet.Packet74GameRule;
+import net.minecraft.core.net.packet.GameRulePacket;
 
 public class GameruleCommand
     extends Command
@@ -67,7 +67,7 @@ public class GameruleCommand
             if (handler.isServer())
             {
                 ServerCommandHandler serverHandler = (ServerCommandHandler) handler;
-                serverHandler.minecraftServer.playerList.sendPacketToAllPlayers(new Packet74GameRule(gameRules));
+                serverHandler.minecraftServer.playerList.sendPacketToAllPlayers(new GameRulePacket(gameRules));
             }
 
             return true;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
index 108c68288..77dade245 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GenerateCommand.java
@@ -2,7 +2,7 @@ package net.minecraft.core.net.command.commands;
 
 import com.b100.utils.Utils;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
@@ -34,7 +34,7 @@ public class GenerateCommand extends Command {
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
 		if(!sender.isPlayer()) throw new CommandError("Must be used by a player!");
-		EntityPlayer player = sender.getPlayer();
+		Player player = sender.getPlayer();
 		
 		if(args.length < 1) return false;
 
@@ -128,7 +128,7 @@ public class GenerateCommand extends Command {
 		}
 		
 		WorldFeature feature = createWorldFeature(worldFeatureClass, constructor, featureArgs);
-		if(!feature.generate(handler.getWorld(player), new Random(), MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z))) {
+		if(!feature.place(handler.getWorld(player), new Random(), MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z))) {
 			throw new CommandError("Could not spawn feature here!");
 		}
 
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
index 80582a346..777a6bc47 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
@@ -1,9 +1,10 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -19,7 +20,7 @@ public class GiveCommand extends Command{
 
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		EntityPlayer player;
+		Player player;
 		Item item;
 		int count = 1;
 		int meta = 0;
@@ -94,18 +95,18 @@ public class GiveCommand extends Command{
 		return Item.itemsList[id];
 	}
 	
-	public static boolean givePlayerItem(CommandHandler handler, CommandSender sender, EntityPlayer player, ItemStack item) {
-		if(player instanceof EntityPlayerSP) {
+	public static boolean givePlayerItem(CommandHandler handler, CommandSender sender, Player player, ItemStack item) {
+		if(player instanceof LocalPlayer) {
 			player.inventory.insertItem(item, true);
 			if(item.stackSize > 0) {
 				player.dropPlayerItem(item);
 			}
 			return true;
 		}
-		if(player instanceof EntityPlayerMP) {
+		if(player instanceof ServerPlayer) {
 			handler.sendCommandFeedback(sender, "Gave "+item.stackSize+" of "+ item.getItemKey() +" to "+player.getDisplayName());
 			
-			EntityPlayerMP playerMP = (EntityPlayerMP) player;
+			ServerPlayer playerMP = (ServerPlayer) player;
 			playerMP.dropPlayerItem(item);
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java b/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java
index a2a21d812..112d1f5a0 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
@@ -18,7 +18,7 @@ public class HarmCommand extends Command
     {
         if (args.length == 0)
         {
-            EntityPlayer player = sender.getPlayer();
+            Player player = sender.getPlayer();
             player.hurt(player, 1, DamageType.GENERIC);
 
             sender.sendMessage("Harmed player " + player.getDisplayName() + "for 1");
@@ -26,7 +26,7 @@ public class HarmCommand extends Command
         }
         else if (args.length == 1)
         {
-            EntityPlayer player = handler.getPlayer(args[0]);
+            Player player = handler.getPlayer(args[0]);
             if (player == null) return false;
 
             player.hurt(player, 1, DamageType.GENERIC);
@@ -35,7 +35,7 @@ public class HarmCommand extends Command
         }
         else if (args.length == 2)
         {
-            EntityPlayer player = handler.getPlayer(args[0]);
+            Player player = handler.getPlayer(args[0]);
             int damageAmount = parseInt(args[1]);
             if (player == null) return false;
 
diff --git a/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java b/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
index 32a059080..b8e7bc8e0 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
+import net.minecraft.core.net.command.ConsoleCommandSender;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -7,6 +8,10 @@ import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.Commands;
 
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.List;
+
 public class HelpCommand extends Command{
 
 	public HelpCommand() {
@@ -43,10 +48,18 @@ public class HelpCommand extends Command{
 		}
 		
 		StringBuilder commandsString = new StringBuilder();
-		
-		for(Command command : Commands.commands) {
+
+		List<Command> commandList = new ArrayList<>(Commands.commands);
+		commandList.sort(Comparator.comparing(Command::getName)); // Sort commands by name
+
+		for(Command command : commandList) {
 			if(sender.isAdmin() || !command.opRequired(null)) {
-				commandsString.append(", ").append(command.getName());
+				if (sender instanceof ConsoleCommandSender) {
+					commandsString.append("\n").append("*    ");
+				} else {
+					commandsString.append(", ");
+				}
+				commandsString.append(command.getName());
 			}
 		}
 		
diff --git a/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java b/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
index 2701bb2a0..dbcbd88cf 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
@@ -16,7 +16,7 @@ public class KillCommand extends Command
     {
         if (args.length == 0)
         {
-            EntityPlayer player = sender.getPlayer();
+            Player player = sender.getPlayer();
             player.killPlayer();
 
             sender.sendMessage("Killed player " + player.getDisplayName());
@@ -24,7 +24,7 @@ public class KillCommand extends Command
         }
         else if (args.length == 1)
         {
-            EntityPlayer player = handler.getPlayer(args[0]);
+            Player player = handler.getPlayer(args[0]);
             if (player == null) return false;
 
             player.killPlayer();
diff --git a/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java b/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
index 5fbcad6df..4f0997f3d 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/PlaySoundCommand.java
@@ -6,7 +6,7 @@ import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.ServerCommandHandler;
-import net.minecraft.core.net.packet.Packet62PlaySoundDirect;
+import net.minecraft.core.net.packet.PlaySoundEffectDirectPacket;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.sound.SoundCategory;
 
@@ -50,9 +50,9 @@ public class PlaySoundCommand extends Command {
         		throw new CommandError("Invalid Sound: '" + soundPath + "'!");
         	}
             if (handler instanceof ServerCommandHandler){
-                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y,z, 128f, dimension, new Packet62PlaySoundDirect(soundId, soundType, x, y, z, volume, pitch));
+                ((ServerCommandHandler) handler).minecraftServer.playerList.sendPacketToPlayersAroundPoint(x, y,z, 128f, dimension, new PlaySoundEffectDirectPacket(soundId, soundType, x, y, z, volume, pitch));
             } else if (handler instanceof ClientCommandHandler){
-                ((ClientCommandHandler) handler).minecraft.sndManager.playSound(soundPath, soundType, x, y, z, volume, pitch);
+                ((ClientCommandHandler) handler).minecraft.sndManager.playSoundAt(soundPath, soundType, x, y, z, volume, pitch);
             }
             return true;
         }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
index 3bf5a4772..f57fd4e2b 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net.command.commands;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.CommandHandler;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
index 4baf98ba4..e59663dbb 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.command.commands;
 
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -17,7 +17,7 @@ public class SetSpawnCommand extends Command{
 
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		EntityPlayer player = sender.getPlayer();
+		Player player = sender.getPlayer();
 		
 		int x, y, z;
 		
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
index acfd41d16..86927b514 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.net.command.commands;
 
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
@@ -19,7 +19,7 @@ public class SpawnCommand extends Command{
 	@Override
 	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
 		if(sender instanceof PlayerCommandSender) {
-			EntityPlayer player = sender.getPlayer();
+			Player player = sender.getPlayer();
 			
 			World world = handler.getWorld(player);
 			
@@ -27,8 +27,8 @@ public class SpawnCommand extends Command{
 			
 			sender.sendMessage("Teleporting to spawn...");
 			
-			if(player instanceof EntityPlayerMP) {
-				EntityPlayerMP playerMP = (EntityPlayerMP) player;
+			if(player instanceof ServerPlayer) {
+				ServerPlayer playerMP = (ServerPlayer) player;
 				if(playerMP.dimension != 0) {
 					playerMP.mcServer.playerList.sendPlayerToOtherDimension(playerMP, 0, false);
 				}
